//+------------------------------------------------------------------+
//|                                                    SpeedUpMa.mq4 |
//|                          Copyright  2008, HomeSoft-Tartan Corp. |
//|                          Copyright  2008, Victor Nicolaev.      |
//|                                          http://www.fxexperts.ru |
//|                                          vinin@mail.ru           |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft-Tartan Corp. && Victor Nicolaev"
#property link      "http://www.fxexperts.ru && vinin@mail.ru"

#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DarkOrange
#property indicator_width1 2
//---- input parameters


extern double b          = 0.7;
extern int    t3_period  = 8;
extern int MA_Start=10;
extern int MA_Step=10;
extern int MA_Count=50;
extern int MA_Mode=0;
extern int MA_Close=3;
extern int Limit=1440;

extern string S1=" ";
extern double LevelUP= 1;              
extern double LevelDN=-1;
extern bool bPlaySound=true;           //     
extern string SoundName="alert.wav";   //  
extern int CheckBar=0;                 //       


double SUpBuff[],speedup,t3;
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3;
//+------------------------------------------------------------------+
//|  LWSMA .                        |
//+------------------------------------------------------------------+
double LRMA(int periodMA, int shift)
  {
    double result=NormalizeDouble(3* iMA( NULL,0,periodMA,0, MODE_LWMA, PRICE_CLOSE, shift) - 
                      2* iMA( NULL,0,periodMA,0, MODE_SMA, PRICE_CLOSE,shift),Digits);   
    return(result);
  }     
//-------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   //SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,SUpBuff);  
   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int limit;
   int i,j;
   double sum=0;
   int counted_bars=IndicatorCounted();   
//----
 if (counted_bars>0) counted_bars--;
       limit=Bars-counted_bars;
   if (Limit>0) limit=MathMin(Limit,limit);     
//---------
 //for (int i=0;i<limit; i++)
   for (i=limit;i>=0; i--)
  {  
     sum=0;
      //for (j=0;j<MA_Count;j++) if (Close[i]>iMA(NULL,0,MA_Start+j*MA_Step,0,MA_Mode,PRICE_CLOSE,i)) sum+=1; else sum-=1;
      //for (j=0;j<MA_Count;j++) if (Close[i]>LRMA(MA_Start+j*MA_Step,i)) sum+=1; else sum-=1;
      for (j=0;j<MA_Count;j++) if (LRMA(MA_Close,i)>LRMA(MA_Start+j*MA_Step,i)) sum+=1; else sum-=1;
      //Buffer[i]=sum/MA_Count;
     speedup=sum/MA_Count;
     //speedup= (iCustom(NULL,0,"SpeedMa-T02",b,t3_period,per,0,i) - iCustom(NULL,0,"SpeedMa-T02",b,t3_period,per,0,i+1))/Point;
     
      e1 = w1*speedup + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;

      t3 = c1*e6 + c2*e5 + c3*e4 + c4*e3;
     
      //SUpBuff[i]=NormalizeDouble(t3,UserDigit);
      SUpBuff[i]=1000*t3;
      
      
         
  }   
  
   if (bPlaySound) {
      if (SUpBuff[CheckBar+1]<=LevelUP   && SUpBuff[CheckBar]>LevelUP) PlaySound(SoundName);
      if (SUpBuff[CheckBar+1]>=LevelDN   && SUpBuff[CheckBar]<LevelDN) PlaySound(SoundName);
            
   }
   return(0);
  }
//+------------------------------------------------------------------+